\name{mareymaps}
\alias{mareymaps}
\docType{data}
\title{ A collection of Marey maps}
\description{
  A marey map is an interpolation between genetical and physical maps of a mapomosome. This data file contains mareymaps for species Arabidopsis thaliana, Caenorabditis elegans, Drosophila melanogaster and Homo sapiens. these maps are held into an object of class MapCollection.
}
\usage{data(mareymaps)}
\format{
mareymaps contains an object \code{mareymaps} of the class \code{\link{MapCollection-class}}. maps inside this object can be accessed using the operator "[[" (see example)
maps are stored as objects of the class \code{\link{MareyMap-class}}. 
the collection contains:

- Set "Arabidopsis thaliana", which contains maps "Chromosome 1", ..., "Chromosome 5".

- Set "Caenorabditis elegans", which contains maps "I", ..., "IV", "V" and "X".

- Set "Drosophila melanogaster", which contains maps "2L", "2R", "3L", "3R", "4", "X".

- Set "Homo sapiens (female)", which contains maps "Chromosome 01", ... , "Chromosome 22"

- Set "Homo sapiens (male)", which contains maps "Chromosome 01", ... , "Chromosome 22"

- Set "Homo sapiens (mean)", which contains maps "Chromosome 01", ... , "Chromosome 22"
}
\source{
  Arabidopsis thaliana: The physical positions were also recorded for those genetic markers that have both been mapped to the Recombinant Inbred (RI) recombination map (see \url{http://nasc.nott.ac.uk/new_ri_map.html}), and have been precisely physically mapped on the basis of flanking sequence, using the marker position information from TAIR. (release 1). Wright SI, Agrawal N, Bureau TE. Effects of recombination rate and gene density on transposable element distributions in Arabidopsis thaliana.Genome Res. 2003 Aug;13(8):1897-903.
  
  
  Caenorabditis elegans: Wormbase Release WS160, \url{http://www.wormbase.org}
  
  
  Drosophila melanogaster: 2nd release of D. mel genome, v 01/1998 Flybase. Marais G, Piganeau G.Hill-Robertson interference is a minor determinant of variations in codon bias across Drosophila melanogaster and Caenorhabditis elegans genomes. Mol Biol Evol. 2002 Sep;19(9):1399-406.

  
  Homo sapiens: Rutgers Combined Linkage-Physical Maps, version 2.0 (Build 35). Xiangyang Komg and Tara Matise 12/08/2004
}
\examples{
data(mareymaps)
map <- mareymaps[["Arabidopsis thaliana","Chromosome 1"]]
plot(map)
}
\keyword{datasets}
