# Copyright 2006 Laboratoire de Biologie et de Biometrie Appliquée 
# (UMR 5558);CNRS; Univ. Lyon 1, 43 bd 11 nov, 69622, 
# Villeurbanne Cedex, France.
#
# This file is part of MareyMapGUI.
#
# MareyMapGUI is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# MareyMapGUI is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MareyMapGUI; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


#--- MenuBar -------------------------------------------------------------------

#--- onSave

setGeneric("onSave",
		function(dummy) standardGeneric("onSave"))

	setMethod("onSave","character",function(dummy){
			dialog <- tktoplevel()
			tkgrab.set(dialog)
			tkwm.title(dialog,"Save")

			curSet <- getVar("curSet")
			curMap <- getVar("curMap")

			frm1 <- tkframe(dialog)
			filepath <- tclVar("")
			entfil <-tkentry(frm1,width="20",textvariable=filepath)
			butbro <- tkbutton(frm1,text="Browse",command=function(){
				fildial <- paste("tk_getSaveFile","-filetypes { \
					{\"R binary files\" {.rda}} \
					{\"text files\" {.txt}} }")
				tclvalue(filepath) <- .Tcl(fildial)
				})
			tkpack(entfil,side="left")
			tkpack(tklabel(frm1),side="left")
			tkpack(butbro,side="left")

			frm2 <- tkframe(dialog)
			rbValue <- tclVar(curMap)
			if(nchar(curSet)>0){
				rbcoll <- tkradiobutton(frm2)
					rbspec <- tkradiobutton(frm2)
					tkpack(rbcoll,side="left")
					tkpack(tklabel(frm2),side="left")
					tkpack(rbspec,side="left")
					tkconfigure(rbcoll,variable=rbValue,value="coll", text="map collection")
					tkconfigure(rbspec,variable=rbValue, value=curSet, text=curSet)
					if(nchar(curMap)>0){
						rbmap <- tkradiobutton(frm2)
							tkpack(tklabel(frm2),side="left")
							tkpack(rbmap,side="left")
							tkconfigure(rbmap,variable=rbValue, value=curMap,
									text=paste(curSet, curMap,sep=", "))
					}
			}else{
				tkpack(tklabel(frm2,text="no set selected, saving every maps"))
					rbValue <- tclVar("coll")
			}

	frm3 <- tkframe(dialog)
		butcan <- tkbutton(frm3,text="Cancel",command=function(){
				tkdestroy(dialog)
				})
	butsav <- tkbutton(frm3,text="Save",command=function(){
			tkdestroy(dialog)
			path <- tclvalue(filepath)
			if(path=="")
			return()
			ext <- substr(path, nchar(path)-2, nchar(path))
			curSet <- getVar("curSet")
			curMap <- getVar("curMap")
			val <- tclvalue(rbValue)
			if(ext=="txt"){
			if(val == curSet){
			set <- regEval("coll[[curSet]]")
			textFile(set,path)
			}
			if(val == curMap){
			map <- regEval("coll[[curSet,curMap]]")
			textFile(map,path)
			}
			if(val == "coll"){
			coll <- getVar("coll")
			textFile(coll,path)
			}
			return()
			}
	if(ext=="rda"){
		if(val == curSet){
			set <- regEval("coll[[curSet]]")
				save("set", file=path)
				tkmessageBox(title="Species saved", 
						message=paste("Species",curSet,"saved to file",path))
		}
		if(val == curMap){
			map <- regEval("coll[[curSet,curMap]]")
				save("map", file=path)
				tkmessageBox(title="map saved", 
						message=paste("map",curSet,"-",curMap,"saved to file",path))
		}
		if(val == "coll"){
			coll <- getVar("coll")
				save("coll", file=path)
				tkmessageBox(title="Collection saved",
						message=paste("collection saved to file",path))
		}
		return()
	}
	tkmessageBox(title="Error",message="file extension not understood.")
	})
	tkpack(butcan,side="left")
		tkpack(butsav,side="right")
		tkpack(tklabel(dialog), frm1, tklabel(dialog), pady=0.2)
		tkpack(tklabel(dialog), frm2, tklabel(dialog), pady=0.2)
		tkpack(tklabel(dialog), frm3, tklabel(dialog), pady=0.2,fill="x")
	})



#--- onOpen

setGeneric("onOpen",
		function(dummy) standardGeneric("onOpen"))

setMethod("onOpen","character",function(dummy){
		fildial <- paste("tk_getOpenFile",
			"-filetypes { 	{\"R binary files\" {.rda .Rdata .Rda}} \
			{\"text files\" {.txt}} \
			{\"All files\" *} }")
		ret <- tclvalue(.Tcl(fildial))
		if(ret=="")
		return()
		if(readLines(ret,n=1) =="RDX2"){
		readRDataFile(ret)
		}else{
		readTextFile(ret)
		}
		})


#--- onExport

setGeneric("onExport",
		function(dummy) standardGeneric("onExport"))

	setMethod("onExport","character",function(dummy){
			dialog <- tktoplevel()
			tkgrab.set(dialog)
			tkwm.title(dialog,"Export")
			frm1 <- tkframe(dialog)
			filepath <- tclVar("")
			entfil <-tkentry(frm1,width="20",textvariable=filepath)
			butbro <- tkbutton(frm1,text="Browse",command=function(){
				fildial <- paste("tk_getSaveFile","-filetypes { \
					{\".eps\" {.eps}} \
					{\".pdf\" {.pdf}} \
					{\".png\" {.png}} \
					{\".jpeg\" {.jpg}} }")
				tclvalue(filepath) <- .Tcl(fildial)
				})

			tkpack(entfil,side="left")
			tkpack(tklabel(frm1),side="left")
			tkpack(butbro,side="left")

			frm2 <- tkframe(dialog)
			rbval <- tclVar("both")
			lblrd <- tklabel(frm2,text="export:")
			rbmap <- tkradiobutton(frm2)
			rbrate <- tkradiobutton(frm2)
			rbboth <- tkradiobutton(frm2)
			tkconfigure(rbmap,variable=rbval,value="map", text="marey map")
			tkconfigure(rbrate,variable=rbval, value="rates", text="recombination rates")
			tkconfigure(rbboth,variable=rbval, value="both", text="both")
			tkpack(lblrd, anchor="nw")
			tkpack(rbmap,side="left")
			tkpack(tklabel(frm2),side="left")
			tkpack(rbrate,side="left")
			tkpack(tklabel(frm2),side="left")
			tkpack(rbboth,side="left")	

			frm3 <- tkframe(dialog)
			butcan <- tkbutton(frm3,text="Cancel",command=function(){
					tkdestroy(dialog)
					})
	butsav <- tkbutton(frm3,text="Export",command=function(){
			path <- tclvalue(filepath)
			if(path=="")
			return()
			ext <- substr(path, nchar(path)-2, nchar(path))
			if(tclvalue(rbval)=="map"){
			if(ext=="eps")
			postscript(file=path, horizontal = FALSE, onefile=FALSE, width=6, height=4.8, paper = "special")
			else if(ext=="pdf")
			pdf(file=path, width=6, height=4.8)
			else if(ext=="png")
			png(file=path, width=480, height=384)
			else if(ext=="jpg")
			jpeg(file=path, width=480, height=384)
			else
			return()
			drawPlt1()
			dev.off()
			}
			if(tclvalue(rbval)=="rates"){
			if(ext=="eps")
			postscript(file=path, horizontal = FALSE, onefile=FALSE, width=6, height=2, paper = "special")
			else if(ext=="pdf")
				pdf(file=path, width=6, height=2)
			else if(ext=="png")
				png(file=path, width=480, height=144)
			else if(ext=="jpg")
				jpeg(file=path, width=480, height=144)
			else
				return()
					drawPlt2()
					dev.off()
			}
			if(tclvalue(rbval)=="both"){
				if(ext=="eps")
					postscript(file=path, horizontal = FALSE, onefile=FALSE, width=6, height=7.2, paper = "special")
				else if(ext=="pdf")
					pdf(file=path, width=6, height=7.2)
				else if(ext=="png")
					png(file=path, width=480, height=576)
				else if(ext=="jpg")
					jpeg(file=path, width=480, height=576)
				else
					return()
						lo <- layout(matrix(c(1,2),2),heights=c(2,1))
						layout.show(lo)
						drawPlt1()
						drawPlt2()
						dev.off()
			}
			tkdestroy(dialog)
	})
	tkpack(butcan,side="left")
		tkpack(butsav,side="right")

		tkpack(tklabel(dialog), frm1, tklabel(dialog), pady=0.2)
		tkpack(tklabel(dialog), frm2, tklabel(dialog), pady=0.2)
		tkpack(tklabel(dialog), frm3, tklabel(dialog), pady=0.2, fill="x")
	})


#--- readTextFile

setGeneric("readTextFile",function(file)standardGeneric("readTextFile"))

	setMethod("readTextFile","character",function(file){
			ll <- readLines(file)
			ll <- ll[grep("@@@",ll)]
			ll <- lapply(ll,function(x){
				x <- unlist(strsplit(x,"@@@"))
				})
			tab <- read.table(as.character(file),header= T)
			sets <- split(tab,tab$set,drop=TRUE)
			coll <- getVar("coll")
			lapply(sets,function(set){
				maps <- split(set,set$map,drop=TRUE)
				lapply(maps,function(map){
					newmap <- as(map,"MareyMap")
					lapply(ll,function(x){
						if(x[[2]]==setName(newmap) && x[[3]]==mapName(newmap)){
						eval(parse(text=paste("itr<-",x[[5]])))
						newmap <<- newmap +itr
						}
						})
#			if(nrow(map)>0){
#				newmap <- MareyMap()
#				idx <- which( (!is.na(as.vector(map[["gen"]]))) )
#				idx <- which( (!is.na(as.vector(map[["phys"]][idx]))) )
#				setName(newmap) <- as.character(map[["species"]][1])
#				mapName(newmap) <- as.character(map[["map"]][1])
#				markerNames(newmap) <- as.vector(map[["name"]][idx])
#				physicalPositions(newmap) <- as.vector(map[["phys"]][idx])
#				geneticDistances(newmap) <- as.vector(map[["gen"]][idx])
#				if("vld" %in% names(map)){
#					markerValidity(newmap) <- as.vector(map[["val"]])
#				}else{
#					markerValidity(newmap) <- rep(T,length(physicalPositions(newmap)))
#				}
#				lapply(ll,function(x){
#					if(x[[2]]==setName(newmap) && x[[3]]==mapName(newmap)){
#						eval(parse(text=paste("itr<-",x[[5]])))
#						newmap <<- newmap +itr
#					}
#				})
	coll <<- coll + newmap
})
})
setVar("coll",coll)
})

onRenameMap <- function(){
	dialog <- tktoplevel()
	tkgrab.set(dialog)
	tkwm.title(dialog,"Rename map")
	frm1 <- tkframe(dialog)
	filepath <- tclVar(getVar("curMap"))
	entfil <-tkentry(frm1,width="20",textvariable=filepath)

	tkpack(tklabel(frm1,text="name: "),entfil,side="left")

	frm3 <- tkframe(dialog)
	butcan <- tkbutton(frm3,text="Cancel",command=function(){
		tkdestroy(dialog)
	})
	butsav <- tkbutton(frm3,text="Rename",command=function(){
		nn <- tclvalue(filepath)
		coll <- getVar("coll")
		curMap <- getVar("curMap")
		curSet <- getVar("curSet")
		set <- coll[[curSet]]
		map <- set[[curMap]]
		set <- set - curMap
		mapName(map)<- nn
		set <- set + map
		coll <- coll + set
		setVar("coll",coll)
		setVar("curMap",nn)
		setVar("curMkr",0)
		tkdestroy(dialog)
	})
	tkpack(butcan,tklabel(frm3),side="left")
	tkpack(butsav,side="right")
	tkpack(tklabel(dialog), frm1, tklabel(dialog), pady=0.2)
	tkpack(tklabel(dialog), frm3, tklabel(dialog), pady=0.2)
}

onRemoveMap <- function(){
	dialog <- tktoplevel()
	tkgrab.set(dialog)
	tkwm.title(dialog,"Confirm")
	frm1 <- tkframe(dialog)
	msglbl <- tklabel(frm1,text="remove this map from the collection ?")
		tkpack(msglbl,side="left")

	frm3 <- tkframe(dialog)
	butno <- tkbutton(frm3,text="No",command=function(){
		tkdestroy(dialog)
	})
	butyes <- tkbutton(frm3,text="Yes",command=function(){
		coll <- getVar("coll")
		curMap <- getVar("curMap")
		curSet <- getVar("curSet")
		set <- coll[[curSet]]
		set <- set - curMap
		coll <- coll + set
		setVar("coll",coll)
		setVar("curMap","")
		setVar("curMkr",0)
		tkdestroy(dialog)
	})
	tkpack(butno,side="left")
	tkpack(butyes,side="right")

	tkpack(tklabel(dialog),
		frm1, tklabel(dialog),
		pady=0.2)
	tkpack(tklabel(dialog),
		frm3, tklabel(dialog),
		pady=0.2, fill="x")
}

onRenameSet <- function(){
	dialog <- tktoplevel()
	tkgrab.set(dialog)
	tkwm.title(dialog,"Rename set")
	frm1 <- tkframe(dialog)
	filepath <- tclVar(getVar("curMap"))
	entfil <-tkentry(frm1,width="20",textvariable=filepath)

	tkpack(tklabel(frm1,text="name: "),entfil,side="left")

	frm3 <- tkframe(dialog)
	butcan <- tkbutton(frm3,text="Cancel",command=function(){
		tkdestroy(dialog)
	})
	butsav <- tkbutton(frm3,text="Rename",command=function(){
		nn <- tclvalue(filepath)
		coll <- getVar("coll")
		curSet <- getVar("curSet")
		set <- coll[[curSet]]
        coll  <- coll - curSet
		setName(set)<- nn
		coll <- coll + set
		setVar("coll",coll)
        setVar("curSet",nn)
        setVar("curMap",getVar("curMap"))
		tkdestroy(dialog)
	})
	tkpack(butcan,tklabel(frm3),side="left")
	tkpack(butsav,side="right")
	tkpack(tklabel(dialog), frm1, tklabel(dialog), pady=0.2)
	tkpack(tklabel(dialog), frm3, tklabel(dialog), pady=0.2)
}

onRemoveSet <- function(){
	dialog <- tktoplevel()
	tkgrab.set(dialog)
	tkwm.title(dialog,"Confirm")
	frm1 <- tkframe(dialog)
	msglbl <- tklabel(frm1,text="remove this set from the collection ?")
		tkpack(msglbl,side="left")

	frm3 <- tkframe(dialog)
	butno <- tkbutton(frm3,text="No",command=function(){
		tkdestroy(dialog)
	})
	butyes <- tkbutton(frm3,text="Yes",command=function(){
		coll <- getVar("coll")
		curMap <- getVar("curMap")
		curSet <- getVar("curSet")
		coll <- coll - curSet
         setVar("curSet","")
		setVar("curMap","")
		setVar("curMkr",0)
		setVar("coll",coll)
       	tkdestroy(dialog)
	})
	tkpack(butno,side="left")
	tkpack(butyes,side="right")

	tkpack(tklabel(dialog),
		frm1, tklabel(dialog),
		pady=0.2)
	tkpack(tklabel(dialog),
		frm3, tklabel(dialog),
		pady=0.2, fill="x")
}

onClearCollection <- function(){
	dialog <- tktoplevel()
	tkgrab.set(dialog)
	tkwm.title(dialog,"Confirm")
	frm1 <- tkframe(dialog)
	msglbl <- tklabel(frm1,text="Clear the collection ?")
		tkpack(msglbl,side="left")

	frm3 <- tkframe(dialog)
	butno <- tkbutton(frm3,text="No",command=function(){
		tkdestroy(dialog)
	})
	butyes <- tkbutton(frm3,text="Yes",command=function(){
        setVar("curSet","")
		setVar("curMap","")
		setVar("curMkr",0)
		setVar("coll",MapCollection())
       	tkdestroy(dialog)
	})
	tkpack(butno,side="left")
	tkpack(butyes,side="right")

	tkpack(tklabel(dialog),
		frm1, tklabel(dialog),
		pady=0.2)
	tkpack(tklabel(dialog),
		frm3, tklabel(dialog),
		pady=0.2, fill="x")
}

#--- readRDataFile

setGeneric("readRDataFile",function(file)standardGeneric("readRDataFile"))

	setMethod("readRDataFile","character",function(file){
			objname <- load(file)
			on.exit(return)
			obj <- get(objname)
#rm("objname")
			if(length(objname)==1){
			if(is(obj,"MapCollection")){
			dialog <- tktoplevel()
			tkwm.title(dialog,"")
			frmbut <- tkframe(dialog)
			merbut <- tkbutton(frmbut,text="Merge",
				command=function(){
				})
			repbut <- tkbutton(frmbut,text="Replace",
				command=function(){
				})
			tkpack(tklabel(frmbut,text=""), merbut, side="left")
			tkpack(repbut, tklabel(frmbut,text=""),side="right")
			tkpack(tklabel(dialog,text=""))
			tkpack(tklabel(dialog,text="The file contains a collection of maps.\
					\n do you want this colection to replace the current\
					one or merge the two collections together ?"))
			tkpack(tklabel(dialog,text=""))
			tkpack(frmbut,fill="x")
			tkpack(tklabel(dialog,text=""))
			return()
			}
			if(is(obj,"MapSet")){
				coll <- getVar("coll") + obj
					setVar("coll",coll)
					setVar("curSet","")
					setVar("curMap","")
					setVar("curMkr",0)
					dialog <- tktoplevel()
					tkwm.title(dialog,"")
					clobut <- tkbutton(dialog,text="Close",
							command=function()tkdestroy(dialog))
					tkgrid(tklabel(dialog,text=""))
					tkgrid(tklabel(dialog,text=
								paste("species \"",setName(obj),
									"\" has been added to the collection.",sep="")),padx=10)
					tkgrid(tklabel(dialog,text=""))
					tkgrid(clobut)
					tkgrid(tklabel(dialog,text=""))
					return()
			}
			if(is(obj,"MareyMap")){
				coll <- getVar("coll") + obj
					setVar("coll",coll)
					setVar("curSet","")
					setVar("curMap","")
					setVar("curMkr",0)
					dialog <- tktoplevel()
					tkwm.title(dialog,"")
					clobut <- tkbutton(dialog,text="Close",
							command=function()tkdestroy(dialog))
					tkgrid(tklabel(dialog,text=""))
					tkgrid(tklabel(dialog,text=
								paste("map \"",setName(obj),", ",mapName(obj),
									"\" has been added to the collection.",sep="")),padx=10)
					tkgrid(tklabel(dialog,text=""))
					tkgrid(clobut)
					tkgrid(tklabel(dialog,text=""))
					return()
			}
			dialog <- tktoplevel()
				tkwm.title(dialog,"Error")
				clobut <- tkbutton(dialog,text="Close",
						command=function()tkdestroy(dialog))
				tkgrid(tklabel(dialog,text=""))
				tkgrid(tklabel(dialog,text=
							paste("invalid object type.",sep="")),padx=10)
				tkgrid(tklabel(dialog,text=""))
				tkgrid(clobut)
				tkgrid(tklabel(dialog,text=""))
				return()
			}
	})

setGeneric("onLoadCollRda",
		function(dummy) standardGeneric("onLoadCollRda"))

setMethod("onLoadCollRda","character",function(dummy){
		fildial <- paste("tk_getOpenFile",
			"-filetypes { {\"R binary files\" {.rda .Rdata .Rda}} {{All files} *} }")
		ret <- .Tcl(fildial)
		if(nchar(tclvalue(ret))==0)
		return
		objname <- load(tclvalue(ret))
		obj <- get(objname)
		if(!is(obj,"MapCollection")){
		dialog <- tktoplevel(parent=mainWin)
		tkwm.title(dialog,"Error")
		clobut <- tkbutton(dialog,text="Close",
			command=function()tkdestroy(dialog))
		tkgrid(tklabel(dialog,text=""))
		tkgrid(tklabel(dialog,text="the Selected file does not contain an object of type MapCollection"),padx=10)
		tkgrid(tklabel(dialog,text=""))
		tkgrid(clobut)
		tkgrid(tklabel(dialog,text=""))
		}else{
		setVar("coll",obj)
		setVar("curSet","")
		setVar("curMap","")
		setVar("curMkr",0)
		dialog <- tktoplevel()
		tkwm.title(dialog,"")
		clobut <- tkbutton(dialog,text="Close",
				command=function()tkdestroy(dialog))
		tkgrid(tklabel(dialog,text=""))
		tkgrid(tklabel(dialog,text="Your working map collection has been changed."),padx=10)
		tkgrid(tklabel(dialog,text=""))
		tkgrid(clobut)
		tkgrid(tklabel(dialog,text=""))
		}
})

setGeneric("onQuit",function(win)standardGeneric("onQuit"))

setMethod("onQuit","ANY",function(win)tkdestroy(win))

onAbout <- function(){
	conn <- file(system.file("about.txt",package="MareyMapGUI"))
		abtdial <- tktoplevel()
		tkwm.title(abtdial,"About MareyMap")
		restxt <- tktext(abtdial)
		clobut <- tkbutton(abtdial,text="close",command=function()
				tkdestroy(abtdial))
		tkgrid(tklabel(abtdial))
		tkgrid(tklabel(abtdial),restxt,tklabel(abtdial))
		tkgrid(tklabel(abtdial))
		tkgrid(tklabel(abtdial),clobut,tklabel(abtdial))
		for(line in readLines(conn)){
			tkinsert(restxt,"end",line)
				tkinsert(restxt,"end","\n")
		}
	tkconfigure(restxt,state="disabled")
}

onLicense <- function(){
	conn <- file(system.file("license.txt",package="MareyMapGUI"))
		abtdial <- tktoplevel()
		tkwm.title(abtdial,"License")
		clobut <- tkbutton(abtdial,text="close",command=function()
				tkdestroy(abtdial))
		tkgrid(tklabel(abtdial))
		tkgrid(tklabel(abtdial),restxt,tklabel(abtdial))
		tkgrid(tklabel(abtdial))
		tkgrid(tklabel(abtdial),clobut,tklabel(abtdial))
		for(line in readLines(conn)){
			tkinsert(restxt,"end",line)
				tkinsert(restxt,"end","\n")
		}
	tkconfigure(restxt,state="disabled")
}

setGeneric("buildSetMenu",function(setMenu) standardGeneric("buildSetMenu"))

setMethod("buildSetMenu","ANY",function(setMenu){
		tkdelete(setMenu,0,"end")

#coll <- getVar("coll")
		curSet <- getVar("curSet")
		names <- regEval("setNames(coll)")
		lapply(names,function(x){
			tkadd(setMenu, "command", label=x,command=function(){
				if(x!=getVar("curSet")){
				setVar("curSet",x)
				setVar("curMap","")
				setVar("curMkr",0)
				}
				})
			})		
		})

setGeneric("MenuBar",function(parent)standardGeneric("MenuBar"))

setMethod("MenuBar","ANY",function(parent){
			menubar <- tkmenu(parent)
# data menu
			fileMenu <- tkmenu(menubar,tearoff=FALSE)
			tkadd(menubar,"cascade",label="File",menu=fileMenu)
			tkadd(fileMenu, "command", label="Open", 
				command=onOpen)
			tkadd(fileMenu, "command", label="Save", 
				command=onSave)
			tkadd(fileMenu, "command", label="Export", 
				command=onExport,state="disabled")
			sep <- tkadd(fileMenu,"separator")
			tkadd(fileMenu, "command", label="Quit", 
				command=function()onQuit(parent))
# Edit menu
			editMenu <- tkmenu(menubar,tearoff=FALSE )
			tkadd(menubar,"cascade",label="Edit",menu=editMenu)
			tkadd(editMenu,"command",label="rename set",
				command=onRenameSet,state="disabled")
			tkadd(editMenu,"command", label="remove set",
				command=onRemoveSet,state="disabled")
			sep <- tkadd(editMenu,"separator")
			tkadd(editMenu,"command",label="rename map",
				command=onRenameMap,state="disabled")
			tkadd(editMenu,"command", label="remove map",
				command=onRemoveMap,state="disabled")
			sep <- tkadd(editMenu,"separator")
			tkadd(editMenu,"command", label="Clear map collection",
				command=onClearCollection)
			
# sets menu
			setMenu <- tkmenu(menubar,tearoff=FALSE)
			tkadd(menubar,"cascade",label="Map sets",menu=setMenu)
			buildSetMenu(setMenu)
# help menu
			hlpMenu <- tkmenu(menubar,tearoff=FALSE)
			tkadd(menubar,"cascade",label="Help",menu=hlpMenu)
			tkadd(hlpMenu,"command",label="Using MareyMap pdf tutorial",
					command=function(){
					f <- system.file("Using_MareyMap.pdf",package="MareyMapGUI")
					viewer <- getOption("pdfviewer")
					if(!is.null(viewer)){
					if(file.exists(viewer))
					system(paste(viewer,f, "&"))
					else
					tkmessageBox(title="Error",message=paste("your\
							current pdf viewer: ",viewer,"does not exist.
							You can change it by setting the variable
							R_PDFVIEWER in you ~/.Renviron file to a correct location.
							Ex: R_PDFVIEWER=/usr/bin/evince"))

					}
					}
				 )
			if(is.null(getOption("pdfviewer")))
				.Tcl(paste(fileMenu, " entryconfigure ",
				0," -state disabled", sep=""))
			tkadd(hlpMenu, "command", label="About", 
					command=onAbout)
			tkadd(hlpMenu, "command", label="License", 
					command=onLicense)

# maps menu
#mapsMenu <- tkmenu(menubar,tearoff=FALSE)
#tkadd(menubar,"cascade",label="Maps",menu=mapsMenu)
#buildMapsMenu(mapsMenu)

					attachCallback("updateMapsAndSetMenu",function(){
#buildMapsMenu(mapsMenu)
							buildSetMenu(setMenu)
							},"curSet")
	attachCallback("updateMapsAndSetMenu",function(){
#buildMapsMenu(mapsMenu)
			buildSetMenu(setMenu)
			},"coll")
#attachCallback("updateMapsMenu",function()#buildMapsMenu(mapsMenu)
#},"curMap")
attachCallback("activeMap",function(){
		if(getVar("curMap")!=""){
		.Tcl(paste(fileMenu, " entryconfigure ",
				2," -state normal", sep=""))

		.Tcl(paste(editMenu, " entryconfigure ",
				3," -state normal", sep=""))
		.Tcl(paste(editMenu, " entryconfigure ",
				4," -state normal", sep=""))

		}else{
		.Tcl(paste(fileMenu, " entryconfigure ",
				2," -state disabled", sep=""))
		
		.Tcl(paste(editMenu, " entryconfigure ",
				3," -state disabled", sep=""))
		.Tcl(paste(editMenu, " entryconfigure ",
				4," -state disabled", sep=""))
		}
		},"curMap")	

attachCallback("activeSet",function(){
		if(getVar("curSet")!=""){
		.Tcl(paste(editMenu, " entryconfigure ",
				0," -state normal", sep=""))
		.Tcl(paste(editMenu, " entryconfigure ",
				1," -state normal", sep=""))

		}else{
		.Tcl(paste(editMenu, " entryconfigure ",
				0," -state disabled", sep=""))
		.Tcl(paste(editMenu, " entryconfigure ",
				1," -state disabled", sep=""))
		}
		},"curSet")

menubar
})

#--- end of MenuBar ------------------------------------------------------------
